	/*436:*/
	#line 8865 "format.w"

#include "basetypes.h"
#include <string.h>
#include <ctype.h>
#include <sys/stat.h>
#include <zlib.h>
#include "error.h"
#include "hformat.h"
#include "hput.h"

	/*252:*/
	#line 5345 "format.w"

range_pos_t*range_pos;
int next_range= 1,max_range;
int*page_on;
	/*:252*/	/*262:*/
	#line 5527 "format.w"

int version= 1,subversion= 1;
char hbanner[MAX_BANNER+1];
	/*:262*/	/*269:*/
	#line 5655 "format.w"

uint8_t*hpos= NULL,*hstart= NULL,*hend= NULL;
	/*:269*/	/*325:*/
	#line 7054 "format.w"

char**hfont_name;
	/*:325*/	/*365:*/
	#line 7816 "format.w"

int option_utf8= false;
int option_hex= false;
int option_force= false;
int option_global= false;
int option_compress= false;

char*in_name;
char*stem_name;
int stem_length= 0;
	/*:365*/	/*368:*/
	#line 7894 "format.w"

FILE*hin= NULL,*hout= NULL;
	/*:368*/
	#line 8875 "format.w"


	/*285:*/
	#line 6043 "format.w"

entry_t*dir= NULL;
uint16_t section_no,max_section_no;
void new_directory(uint32_t entries)
{DBG(DBGDIR,"Creating directory with %d entries\n",entries);
RNG("Directory entries",entries,3,0x10000);
max_section_no= entries-1;
ALLOCATE(dir,entries,entry_t);
dir[0].section_no= 0;dir[1].section_no= 1;dir[2].section_no= 2;
}
	/*:285*/	/*286:*/
	#line 6056 "format.w"

void hset_entry(entry_t*e,uint16_t i,uint32_t size,uint32_t xsize,char*file_name)
{e->section_no= i;
e->size= size;e->xsize= xsize;
if(file_name==NULL||*file_name==0)
e->file_name= NULL;
else
e->file_name= strdup(file_name);
DBG(DBGDIR,"Creating entry %d: \"%s\" size=0x%x xsize=0x%x\n",i,file_name,size,xsize);
}
	/*:286*/
	#line 8877 "format.w"

	/*266:*/
	#line 5592 "format.w"


static size_t hput_banner(char*magic,char*s)
{return fprintf(hout,"%s %d.%d %s\n",magic,version,subversion,s);
}
	/*:266*/
	#line 8878 "format.w"

	/*12:*/
	#line 645 "format.w"

uint8_t hput_glyph(glyph_t*g)
{info_t info;
if(g->c<=0xFF)
{HPUT8(g->c);info= 1;}
else if(g->c<=0xFFFF)
{HPUT16(g->c);info= 2;}
else if(g->c<=0xFFFFFF)
{HPUT24(g->c);info= 3;}
else
{HPUT32(g->c);info= 4;}
HPUT8(g->f);
return TAG(glyph_kind,info);
}
	/*:12*/	/*13:*/
	#line 663 "format.w"

void hput_tags(uint32_t pos,uint8_t tag)
{DBGTAG(tag,hstart+pos);DBGTAG(tag,hpos);
HPUTX(1);*(hstart+pos)= *(hpos++)= tag;
}
	/*:13*/	/*34:*/
	#line 1001 "format.w"

void hput_string(char*str)
{char*s= str;
if(s!=NULL)
{do{
HPUTX(1);
HPUT8(*s);
}while(*s++!=0);
HPUTNODE;
}
else HPUT8(0);
}
	/*:34*/	/*51:*/
	#line 1208 "format.w"

void hput_utf8(uint32_t c)
{HPUTX(4);
if(c<0x80)
HPUT8(c);
else if(c<0x800)
{HPUT8(0xC0|(c>>6));HPUT8(0x80|(c&0x3F));}
else if(c<0x10000)
{HPUT8(0xE0|(c>>12));HPUT8(0x80|((c>>6)&0x3F));HPUT8(0x80|(c&0x3F));}
else if(c<0x200000)
{HPUT8(0xF0|(c>>18));HPUT8(0x80|((c>>12)&0x3F));
HPUT8(0x80|((c>>6)&0x3F));HPUT8(0x80|(c&0x3F));}
else
RNG("character code",c,0,0x1FFFFF);
}
	/*:51*/	/*72:*/
	#line 1550 "format.w"

void hput_float32(float32_t d)
{union{float32_t d;uint32_t bits;}u;
u.d= d;HPUT32(u.bits);
}
	/*:72*/	/*83:*/
	#line 1661 "format.w"


uint8_t hput_dimen(dimen_t d)
{HPUT32(d);
return TAG(dimen_kind,b001);
}
	/*:83*/	/*92:*/
	#line 1782 "format.w"

uint8_t hput_xdimen(xdimen_t*x)
{info_t info= b000;
if(x->w==0&&x->h==0.0&&x->v==0.0){HPUT32(0);info|= b100;}
else
{if(x->w!=0){HPUT32(x->w);info|= b100;}
if(x->h!=0.0){hput_float32(x->h);info|= b010;}
if(x->v!=0.0){hput_float32(x->v);info|= b001;}
}
return TAG(xdimen_kind,info);
}
void hput_xdimen_node(xdimen_t*x)
{uint32_t p= hpos++-hstart;
hput_tags(p,hput_xdimen(x));
}


	/*:92*/	/*94:*/
	#line 1836 "format.w"

void hput_stretch(stretch_t*s)
{uint32_t mantissa,lowbits,sign,exponent;
stch_t st;
st.f= s->f;
DBG(DBGFLOAT,"joining %f->%f(0x%X),%d:",s->f,st.f,st.u,s->o);
mantissa= st.u&(((uint32_t)1<<FLT_M_BITS)-1);
lowbits= mantissa&0x7;
exponent= (st.u>>FLT_M_BITS)&(((uint32_t)1<<FLT_E_BITS)-1);
sign= st.u&((uint32_t)1<<(FLT_E_BITS+FLT_M_BITS));
DBG(DBGFLOAT,"s=%d e=0x%x m=0x%x",sign,exponent,mantissa);
switch(lowbits)
{case 0:break;
case 1:mantissa= mantissa-1;break;
case 2:mantissa= mantissa-2;break;
case 3:mantissa= mantissa+1;break;
case 4:break;
case 5:mantissa= mantissa-1;break;
case 6:mantissa= mantissa+1;
case 7:mantissa= mantissa+1;
if(mantissa>=((uint32_t)1<<FLT_M_BITS))
{exponent++;
RNG("Float32 exponent",exponent,1,2*FLT_EXCESS);
mantissa= mantissa>>1;
}
break;
}
DBG(DBGFLOAT," round s=%d e=0x%x m=0x%x",sign,exponent,mantissa);
st.u= sign|(exponent<<FLT_M_BITS)|mantissa|s->o;
DBG(DBGFLOAT,"float %f hex 0x%x\n",st.f,st.u);
HPUT32(st.u);
}
	/*:94*/	/*105:*/
	#line 1973 "format.w"

uint8_t hput_int(int32_t n)
{info_t info;
if(n>=0)
{if(n<0x80){HPUT8(n);info= 1;}
else if(n<0x8000){HPUT16(n);info= 2;}
else{HPUT32(n);info= 4;}
}
else
{if(n>=-0x80){HPUT8(n);info= 1;}
else if(n>=-0x8000){HPUT16(n);info= 2;}
else{HPUT32(n);info= 4;}
}
return TAG(int_kind,info);
}
	/*:105*/	/*109:*/
	#line 2048 "format.w"

uint8_t hput_language(uint8_t n)
{if(n<7)return TAG(language_kind,n+1);
HPUT8(n);return TAG(language_kind,0);
}
	/*:109*/	/*119:*/
	#line 2183 "format.w"

uint8_t hput_rule(rule_t*r)
{info_t info= b000;
if(r->h!=RUNNING_DIMEN){HPUT32(r->h);info|= b100;}
if(r->d!=RUNNING_DIMEN){HPUT32(r->d);info|= b010;}
if(r->w!=RUNNING_DIMEN){HPUT32(r->w);info|= b001;}
return TAG(rule_kind,info);
}
	/*:119*/	/*129:*/
	#line 2419 "format.w"

uint8_t hput_glue(glue_t*g)
{info_t info= b000;
if(ZERO_GLUE(*g)){HPUT8(zero_skip_no);info= b000;}
else if((g->w.w==0&&g->w.h==0.0&&g->w.v==0.0))
{if(g->p.f!=0.0){hput_stretch(&g->p);info|= b010;}
if(g->m.f!=0.0){hput_stretch(&g->m);info|= b001;}
}
else if(g->w.h==0.0&&g->w.v==0.0&&(g->p.f==0.0||g->m.f==0.0))
{HPUT32(g->w.w);info= b100;
if(g->p.f!=0.0){hput_stretch(&g->p);info|= b010;}
if(g->m.f!=0.0){hput_stretch(&g->m);info|= b001;}
}
else
{hput_xdimen_node(&(g->w));
hput_stretch(&g->p);hput_stretch(&g->m);
info= b111;
}
return TAG(glue_kind,info);
}
	/*:129*/	/*137:*/
	#line 2716 "format.w"

uint8_t hsize_bytes(uint32_t n)
{if(n==0)return 0;
else if(n<0x100)return 1;
else if(n<0x10000)return 2;
else if(n<0x1000000)return 3;
else return 4;
}

void hput_list_size(uint32_t n,int i)
{if(i==0);
else if(i==1)HPUT8(n);
else if(i==2)HPUT16(n);
else if(i==3)HPUT24(n);
else HPUT32(n);
}

uint8_t hput_list(uint32_t start_pos,list_t*l)
{if(l->s==0)
{hpos= hstart+start_pos;return TAG(l->k,1);}
else
{uint32_t list_end= hpos-hstart;
info_t i= l->p-start_pos-1;
info_t j= hsize_bytes(l->s);
DBG(DBGNODE,"Put list at 0x%x size=%u\n",l->p,l->s);
if(i>j&&l->s>0x100)j= i;
if(i!=j)
{int d= j-i;
DBG(DBGNODE,"Moving %u byte by %d\n",l->s,d);
memmove(hstart+l->p+d,hstart+l->p,l->s);
l->p= l->p+d;
list_end= list_end+d;
}
hpos= hstart+start_pos;hput_list_size(l->s,j);HPUT8(0x100-j);
hpos= hstart+list_end;HPUT8(0x100-j);hput_list_size(l->s,j);
return TAG(l->k,j+1);
}
}

	/*:137*/	/*148:*/
	#line 3155 "format.w"


void hput_txt_cc(uint32_t c)
{if(c<=0x20){HPUTX(2);HPUT8(txt_cc);HPUT8(c);}
else hput_utf8(c);
}

void hput_txt_font(uint8_t f)
{if(f<8)HPUTX(1),HPUT8(txt_font+f);
else QUIT("Use \\F%d\\ instead of \\%d for font %d in a text",f,f,f);
}

void hput_txt_global(ref_t*d)
{HPUTX(2);
switch(d->k)
{case font_kind:HPUT8(txt_global+0);break;
case penalty_kind:HPUT8(txt_global+1);break;
case kern_kind:HPUT8(txt_global+2);break;
case ligature_kind:HPUT8(txt_global+3);break;
case hyphen_kind:HPUT8(txt_global+4);break;
case glue_kind:HPUT8(txt_global+5);break;
case language_kind:HPUT8(txt_global+6);break;
case rule_kind:HPUT8(txt_global+7);break;
case image_kind:HPUT8(txt_global+8);break;
default:QUIT("Kind %s not allowed as a global reference in a text",NAME(d->k));
}
HPUT8(d->n);
}

void hput_txt_local(uint8_t n)
{HPUTX(1);
HPUT8(txt_local+n);
}
	/*:148*/	/*158:*/
	#line 3369 "format.w"


info_t hput_box_dimen(dimen_t h,dimen_t d,dimen_t w)
{info_t i;
HPUT32(h);
if(d!=0){HPUT32(d);i= b001;}else i= b000;
HPUT32(w);
return i;
}
info_t hput_box_shift(dimen_t a)
{if(a!=0){HPUT32(a);return b010;}else return b000;
}

info_t hput_box_glue_set(int8_t s,float32_t r,order_t o)
{if(r!=0.0&&s!=0)
{hput_float32(r);
HPUT8((s<<4)|o);
return b100;
}
else return b000;
}

	/*:158*/	/*171:*/
	#line 3633 "format.w"

uint8_t hput_kern(kern_t*k)
{info_t info;
if(k->x)info= b100;else info= b000;
if(k->d.h==0.0&&k->d.v==0.0)
{if(k->d.w==0)HPUT8(zero_dimen_no);
else{HPUT32(k->d.w);info= info|2;}
}
else{hput_xdimen_node(&(k->d));info= info|3;}
return TAG(kern_kind,info);
}
	/*:171*/	/*184:*/
	#line 3819 "format.w"

uint8_t hput_baseline(baseline_t*b)
{info_t info= b000;
if(!ZERO_GLUE(b->bs))info|= b100;
if(!ZERO_GLUE(b->ls))info|= b010;
if(b->lsl!=0){HPUT32(b->lsl);info|= b001;}
return TAG(baseline_kind,info);
}
	/*:184*/	/*192:*/
	#line 3925 "format.w"

uint8_t hput_ligature(lig_t*l)
{if(l->l.s<7)return TAG(ligature_kind,l->l.s);
else
{memmove(hstart+l->l.p+1,hstart+l->l.p,l->l.s);hpos++;
*(hstart+l->l.p)= *hpos++= l->l.s;
return TAG(ligature_kind,7);
}
}
	/*:192*/	/*201:*/
	#line 4041 "format.w"

uint8_t hput_hyphen(hyphen_t*h)
{info_t info= b000;
if(h->p.s>0)info|= b100;
if(h->q.s>0)info|= b010;
if(h->x||h->r!=0||info==b000){info|= b001;HPUT8(h->r|(h->x?0x80:0x00));}
return TAG(hyphen_kind,info);
}
	/*:201*/	/*227:*/
	#line 4441 "format.w"

uint8_t hput_item(uint32_t n)
{if(n==0)QUIT("Span count in item must not be zero");
else if(n<7)return TAG(item_kind,n);
else if(n>0xFF)QUIT("Span count %d must be less than 255",n);
else
{HPUT8(n);return TAG(item_kind,7);}
}
	/*:227*/	/*235:*/
	#line 4528 "format.w"

uint8_t hput_image(image_t*x)
{info_t i= b100;
HPUT16(x->n);
if(x->w!=0||x->h!=0){HPUT32(x->w);HPUT32(x->h);i|= b010;}
if(x->p.f!=0.0||x->m.f!=0.0){hput_stretch(&x->p);hput_stretch(&x->m);i|= b001;}
return TAG(image_kind,i);
}
	/*:235*/	/*260:*/
	#line 5440 "format.w"

void hput_range(uint8_t pg,bool on)
{if(((next_range-1)/2)>max_ref[range_kind])
QUIT("Page range %d > %d",(next_range-1)/2,max_ref[range_kind]);
if(on&&page_on[pg]!=0)
QUIT("Template %d is switched on at 0x%x and "SIZE_F,
pg,range_pos[page_on[pg]].pos,hpos-hstart);
else if(!on&&page_on[pg]==0)
QUIT("Template %d is switched off at "SIZE_F" but was not on",
pg,hpos-hstart);
DBG(DBGRANGE,"Range *%d %s at "SIZE_F"\n",pg,on?"on":"off",hpos-hstart);
range_pos[next_range].pg= pg;
range_pos[next_range].pos= hpos-hstart;
range_pos[next_range].on= on;
if(on)page_on[pg]= next_range;
else{range_pos[next_range].link= page_on[pg];
range_pos[page_on[pg]].link= next_range;
page_on[pg]= 0;}
next_range++;
}
extern void hput_definitions_end(void);
void hput_range_defs(void)
{int i;
section_no= 1;
hstart= dir[1].buffer;
hend= hstart+dir[1].bsize;
hpos= hstart+dir[1].size;
for(i= 1;i<next_range;i++)
if(range_pos[i].on)
{info_t info= b000;
uint32_t p= hpos++-hstart;
uint32_t from,to;
HPUT8(range_pos[i].pg);
from= range_pos[i].pos;
if(range_pos[i].link!=0)to= range_pos[range_pos[i].link].pos;
else to= 0xFFFFFFFF;
if(from!=0)
{info= info|b100;if(from>0xFFFF)info= info|b001;}
if(to!=0xFFFFFFFF)
{info= info|b010;if(to>0xFFFF)info= info|b001;}
if(info&b100)
{if(info&b001)HPUT32(from);else HPUT16(from);}
if(info&b010)
{if(info&b001)HPUT32(to);else HPUT16(to);}
DBG(DBGRANGE,"Range *%d from 0x%x to 0x%x\n",range_pos[i].pg,from,to);
hput_tags(p,TAG(range_kind,info));
}
hput_definitions_end();
}
	/*:260*/	/*268:*/
	#line 5626 "format.w"

static size_t hput_root(void);
static size_t hput_section(uint16_t n);
static void hput_optional_sections(void);

void hput_hint(char*str)
{size_t s;
DBG(DBGBASIC,"Writing hint output %s\n",str);
s= hput_banner("hint",str);
DBG(DBGDIR,"Root Entry at "SIZE_F"\n",s);
s+= hput_root();
DBG(DBGDIR,"Directory section at "SIZE_F"\n",s);
s+= hput_section(0);
DBG(DBGDIR,"Definition section at "SIZE_F"\n",s);
s+= hput_section(1);
DBG(DBGDIR,"Content section at "SIZE_F"\n",s);
s+= hput_section(2);
DBG(DBGDIR,"Auxiliary sections at "SIZE_F"\n",s);
hput_optional_sections();
}
	/*:268*/	/*271:*/
	#line 5675 "format.w"

void hput_error(void)
{if(hpos<hend)return;
QUIT("HPUT overrun section %d pos="SIZE_F"\n",section_no,hpos-hstart);
}
	/*:271*/	/*278:*/
	#line 5840 "format.w"

#define BUFFER_SIZE 0x400
void new_output_buffers(void)
{dir[0].bsize= dir[1].bsize= dir[2].bsize= BUFFER_SIZE;
DBG(DBGBUFFER,"Allocating output buffer size=0x%x, margin=0x%x\n",BUFFER_SIZE,MAX_TAG_DISTANCE);
ALLOCATE(dir[0].buffer,dir[0].bsize+MAX_TAG_DISTANCE,uint8_t);
ALLOCATE(dir[1].buffer,dir[1].bsize+MAX_TAG_DISTANCE,uint8_t);
ALLOCATE(dir[2].buffer,dir[2].bsize+MAX_TAG_DISTANCE,uint8_t);
}

void hput_increase_buffer(uint32_t n)
{size_t bsize;
uint32_t pos;
const double buffer_factor= 1.4142136;
pos= hpos-hstart;
bsize= dir[section_no].bsize*buffer_factor+0.5;
if(bsize<pos+n)bsize= pos+n;
if(bsize>=0xFFFFFFFF)bsize= 0xFFFFFFFF;
if(bsize<pos+n)QUIT("Unable to increase buffer size "SIZE_F" by 0x%x byte",hpos-hstart,n);
DBG(DBGBUFFER,"Reallocating output buffer "" for section %d from 0x%x to "SIZE_F" byte\n",
section_no,dir[section_no].bsize,bsize);
REALLOCATE(dir[section_no].buffer,bsize,uint8_t);
dir[section_no].bsize= (uint32_t)bsize;
hstart= dir[section_no].buffer;
hend= hstart+bsize;
hpos= hstart+pos;
}


static size_t hput_data(uint16_t n,uint8_t*buffer,uint32_t size)
{size_t s;
s= fwrite(buffer,1,size,hout);
if(s!=size)
QUIT("short write "SIZE_F" < %d in section %d",s,size,n);
return s;
}

static size_t hput_section(uint16_t n)
{return hput_data(n,dir[n].buffer,dir[n].size);
}
	/*:278*/	/*298:*/
	#line 6360 "format.w"

static void hput_entry(entry_t*e)
{uint8_t b;
if(e->size<0x100&&e->xsize<0x100)b= 0;
else if(e->size<0x10000&&e->xsize<0x10000)b= 1;
else if(e->size<0x1000000&&e->xsize<0x1000000)b= 2;
else b= 3;
if(e->xsize!=0)b= b|b100;
DBG(DBGTAGS,"Directory entry no=%d size=0x%x xsize=0x%x\n",e->section_no,e->size,e->xsize);
HPUTTAG(0,b);
HPUT16(e->section_no);
switch(b){
case 0:HPUT8(e->size);break;
case 1:HPUT16(e->size);break;
case 2:HPUT24(e->size);break;
case 3:HPUT32(e->size);break;
case b100|0:HPUT8(e->size);HPUT8(e->xsize);break;
case b100|1:HPUT16(e->size);HPUT16(e->xsize);break;
case b100|2:HPUT24(e->size);HPUT24(e->xsize);break;
case b100|3:HPUT32(e->size);HPUT32(e->xsize);break;
default:QUIT("Can't happen");break;
}
hput_string(e->file_name);
DBGTAG(TAG(0,b),hpos);HPUT8(TAG(0,b));
}

static void hput_directory_start(void)
{DBG(DBGDIR,"Directory Section\n");
section_no= 0;
hpos= hstart= dir[0].buffer;
hend= hstart+dir[0].bsize;
}
static void hput_directory_end(void)
{dir[0].size= hpos-hstart;
DBG(DBGDIR,"End Directory Section size=0x%x\n",dir[0].size);
}

static size_t hput_root(void)
{uint8_t buffer[MAX_TAG_DISTANCE];
size_t s;
hpos= hstart= buffer;
hend= hstart+MAX_TAG_DISTANCE;
dir[0].section_no= max_section_no;
hput_entry(&dir[0]);
s= hput_data(0,hstart,hpos-hstart);
DBG(DBGDIR,"Writing Root size="SIZE_F"\n",s);
return s;
}
	/*280:*/
	#line 5932 "format.w"

static void hcompress(uint16_t n)
{z_stream z;
uint8_t*buffer;
int i;
if(dir[n].size==0){dir[n].xsize= 0;return;}
DBG(DBGCOMPRESS,"Compressing section %d of size 0x%x\n",n,dir[n].size);
z.zalloc= (alloc_func)0;
z.zfree= (free_func)0;
z.opaque= (voidpf)0;
if(deflateInit(&z,Z_DEFAULT_COMPRESSION)!=Z_OK)
QUIT("Unable to initialize compression: %s",z.msg);
ALLOCATE(buffer,dir[n].size+MAX_TAG_DISTANCE,uint8_t);
z.next_out= buffer;
z.avail_out= dir[n].size+MAX_TAG_DISTANCE;
z.next_in= dir[n].buffer;
z.avail_in= dir[n].size;
i= deflate(&z,Z_FINISH);
DBG(DBGCOMPRESS,"deflate in: avail/total=0x%x/0x%lx out: avail/total=0x%x/0x%lx, return %d;\n",
z.avail_in,z.total_in,z.avail_out,z.total_out,i);
if(z.avail_in!=0)
QUIT("Compression missed input data");
if(i!=Z_STREAM_END)
QUIT("Compression incomplete: %s",z.msg);
if(deflateEnd(&z)!=Z_OK)
QUIT("Unable to finalize compression: %s",z.msg);
DBG(DBGCOMPRESS,"Compressed 0x%lx byte to 0x%lx byte\n",z.total_in,z.total_out);
free(dir[n].buffer);
dir[n].buffer= buffer;
dir[n].bsize= dir[n].size+MAX_TAG_DISTANCE;
dir[n].xsize= dir[n].size;
dir[n].size= z.total_out;
}
	/*:280*/
	#line 6408 "format.w"

extern int option_compress;
void hput_directory(void)
{int i;
	/*297:*/
	#line 6339 "format.w"

{int i;
for(i= 3;i<=max_section_no;i++)
{struct stat s;
char*file_name= dir[i].file_name;
int file_name_length= 0;
	/*289:*/
	#line 6106 "format.w"

if(!option_global)
{int path_length= (int)strlen(file_name);
	/*290:*/
	#line 6121 "format.w"

enum{absolute= 0,relative= 1}name_type;
char*aux_ext[2]= {".abs/",".rel/"};
int ext_length= 5;
if(file_name[0]=='/')
{name_type= absolute;
file_name++;path_length--;
}
else if(path_length>3&&isalpha(file_name[0])&&
file_name[1]==':'&&file_name[2]=='/')
{name_type= absolute;
file_name[1]= '_';
}
else
name_type= relative;
	/*:290*/
	#line 6109 "format.w"

if(file_name_length<stem_length+ext_length+path_length)
{file_name_length= stem_length+ext_length+path_length;
REALLOCATE(stem_name,file_name_length+1,char);
}
strcpy(stem_name+stem_length,aux_ext[name_type]);
strcpy(stem_name+stem_length+ext_length,file_name);
DBG(DBGDIR,"Replacing auxiliar file name:\n\t%s\n->\t%s\n",file_name,stem_name);
file_name= stem_name;
}
	/*:289*/
	#line 6345 "format.w"

if(stat(file_name,&s)!=0)
QUIT("Unable to obtain file size for '%s'",dir[i].file_name);
dir[i].size= s.st_size;
dir[i].xsize= 0;
}
}
	/*:297*/
	#line 6412 "format.w"

if(option_compress){hcompress(1);hcompress(2);}
hput_directory_start();
for(i= 1;i<=max_section_no;i++)
{dir[i].pos= dir[i-1].pos+dir[i-1].size;
DBG(DBGDIR,"writing entry %u at 0x%"PRIx64"\n",i,dir[i].pos);
hput_entry(&dir[i]);
}
hput_directory_end();
if(option_compress)hcompress(0);
}

	/*:298*/	/*299:*/
	#line 6436 "format.w"

static void hput_optional_sections(void)
{int i;
DBG(DBGDIR,"Optional Sections\n");
for(i= 3;i<=max_section_no;i++)
{FILE*f;
size_t fsize;
char*file_name= dir[i].file_name;
int file_name_length= 0;
DBG(DBGDIR,"file %d: %s\n",dir[i].section_no,file_name);
if(dir[i].xsize!=0)
DBG(DBGDIR,"Compressing of auxiliary files currently not supported");
	/*289:*/
	#line 6106 "format.w"

if(!option_global)
{int path_length= (int)strlen(file_name);
	/*290:*/
	#line 6121 "format.w"

enum{absolute= 0,relative= 1}name_type;
char*aux_ext[2]= {".abs/",".rel/"};
int ext_length= 5;
if(file_name[0]=='/')
{name_type= absolute;
file_name++;path_length--;
}
else if(path_length>3&&isalpha(file_name[0])&&
file_name[1]==':'&&file_name[2]=='/')
{name_type= absolute;
file_name[1]= '_';
}
else
name_type= relative;
	/*:290*/
	#line 6109 "format.w"

if(file_name_length<stem_length+ext_length+path_length)
{file_name_length= stem_length+ext_length+path_length;
REALLOCATE(stem_name,file_name_length+1,char);
}
strcpy(stem_name+stem_length,aux_ext[name_type]);
strcpy(stem_name+stem_length+ext_length,file_name);
DBG(DBGDIR,"Replacing auxiliar file name:\n\t%s\n->\t%s\n",file_name,stem_name);
file_name= stem_name;
}
	/*:289*/
	#line 6448 "format.w"

f= fopen(file_name,"rb");
if(f==NULL)QUIT("Unable to read section %d, file %s",
dir[i].section_no,file_name);
fsize= 0;
while(!feof(f))
{size_t s,t;
char buffer[1<<13];
s= fread(buffer,1,1<<13,f);
t= fwrite(buffer,1,s,hout);
if(s!=t)QUIT("writing file %s",file_name);
fsize= fsize+t;
}
fclose(f);
if(fsize!=dir[i].size)
QUIT("File size "SIZE_F" does not match directory size %u",fsize,dir[i].size);
}
}
	/*:299*/	/*305:*/
	#line 6553 "format.w"

void hput_definitions_start(void)
{DBG(DBGDEF,"Definition Section\n");
section_no= 1;
hpos= hstart= dir[1].buffer;
hend= hstart+dir[1].bsize;
}
void hput_definitions_end(void)
{dir[1].size= hpos-hstart;
DBG(DBGDEF,"End Definition Section size=0x%x\n",dir[1].size);
}
	/*:305*/	/*313:*/
	#line 6705 "format.w"

void hput_max_definitions(void)
{kind_t k;
DBG(DBGDEF,"Max Definitions Begin\n");
HPUTTAG(list_kind,0);
for(k= 0;k<32;k++)
if(max_ref[k]>max_default[k])
{DBG(DBGDEF,"max(%s) = %d\n",definition_name[k],max_ref[k]);
HPUTTAG(k,1);
HPUT8(max_ref[k]);
HPUTTAG(k,1);
}
HPUTTAG(list_kind,0);
DBG(DBGDEF,"Max Definitions End\n");
}
	/*:313*/	/*332:*/
	#line 7151 "format.w"

uint8_t hput_font_head(uint8_t f,char*n,dimen_t s,uint16_t m,uint16_t y)
{info_t i= b000;
DBG(DBGDEF,"Defining font %d (%s) size 0x%x\n",f,n,s);
hput_string(n);
HPUT32(s);
HPUT16(m);HPUT16(y);
return TAG(font_kind,i);
}
	/*:332*/	/*361:*/
	#line 7722 "format.w"

void hput_content_start(void)
{DBG(DBGDIR,"Content Section\n");
section_no= 2;
hpos= hstart= dir[2].buffer;
hend= hstart+dir[2].bsize;

}
void hput_content_end(void)
{
dir[2].size= hpos-hstart;
DBG(DBGDIR,"End Content Section, size=0x%x\n",dir[2].size);
}
	/*:361*/
	#line 8879 "format.w"

	/*:436*/
